{*******************************************************************************

Unit UBlock.pas

Copyright CNRS (juin 2007)
auteur : Sylvain Mottet
sylvain.mottet @ univ-paris5.fr

Ce logiciel est rgi par la licence CeCILL-C soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-C telle que diffuse par le CEA, le CNRS et l'INRIA
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme, le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,  l'utilisation,  la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant
donn sa spcificit de logiciel libre, qui peut le rendre complexe 
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant des connaissances informatiques approfondies. Les
utilisateurs sont donc invits  charger et tester l'adquation du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement,
 l'utiliser et l'exploiter dans les mmes conditions de scurit.

Le fait que vous puissiez accder  cet en-tte signifie que vous avez
pris connaissance de la licence CeCILL-C, et que vous en avez accept les
termes.

*******************************************************************************}

unit UBlock;

interface

uses
  UTrial, IniFiles;

type

  TBlock = class
    Name: String;
    Description: String;
    PauseBefore: Boolean;
    Entered: Boolean;
    ShuffleTrials: Boolean;
    Trials: array of TTrial;

    constructor Create;
    function  AddOptions(options: String): Boolean;
    function  AddTrials(value: String; trialarray: array of TTrial): Boolean;
    procedure Shuffle;
  end;

  function FindBlockByName(aoblocks: array of TBlock; blname: String): Integer;

implementation

uses
  Dialogs,
  Classes, // TStringList
  Tools;

function FindBlockByName(aoblocks: array of TBlock; blname: String): Integer;
var
  i: Integer;
begin
  for i := 0 to High(aoblocks) do
    if ( aoblocks[i].Name = blname ) then
    begin
      Result := i;
      Exit;
    end;
  Result := -1; // not found
end;

constructor TBlock.Create;
begin
  inherited;
  Self.PauseBefore := False;
  Self.ShuffleTrials := False;
  Self.Entered := False;
end;

function TBlock.AddOptions(options: String): Boolean;
var
  i: Integer;
  keylist: TStringList;
begin
  Result := True; // no unknown option
  keylist := TStringList.Create;
  SplitString(options, ',', keylist, fTrim + fLower);
  for i := 0 to keylist.Count - 1 do
  begin
    if ( keylist[i] = 'pause_before' ) then
    begin
      Self.PauseBefore := True;
      continue;
    end;
    if ( keylist[i] = 'randomize' ) then
    begin
      Self.ShuffleTrials := True;
      continue;
    end;
    MessageDlg(PChar('Bloc ' + Self.Name + ' : option ' + keylist[i] + ' inconnue.'), mtWarning, [mbOK], 0);
    Result := False;
  end;
end;

function TBlock.AddTrials(value: String; trialarray: array of TTrial): Boolean;
var
  i: Integer;
  triallist: TStringList;
  trialindex: Integer;
begin
  Result := True;
  triallist := TStringList.Create;
  SplitString(value, ',', triallist, fTrim);
  for i := 0 to triallist.Count - 1 do
  begin
    trialindex := FindTrialByName(trialarray, triallist[i]);
    if ( trialindex = -1 ) then
    begin
      MessageDlg(PChar('Bloc ' + Self.Name + ' : essai <' + triallist[i] + '> non trouv.'),
                 mtError, [mbOK], 0);
      Result := False;
    end
    else
    begin
      SetLength(Self.Trials, Length(Self.Trials) + 1);
      Self.Trials[High(Self.Trials)] := trialarray[trialindex];
    end;
  end;
end;

procedure TBlock.Shuffle;
var
  i, j, k: Integer;
  tr: TTrial;
begin
  if ( Self.ShuffleTrials = True ) then
    for i := 0 to Length(Trials) * 2 do
    begin
      j := Random(Length(Trials));
      k := Random(Length(Trials));
      if ( j <> k ) then
      begin
        tr := Trials[j];
        Trials[j] := Trials[k];
        Trials[k] := tr;
      end;
    end;
end;

end.
