{*******************************************************************************

Unit UFormIntro.pas

Copyright CNRS (juin 2007)
auteur : Sylvain Mottet
sylvain.mottet @ univ-paris5.fr

Ce logiciel est rgi par la licence CeCILL-C soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-C telle que diffuse par le CEA, le CNRS et l'INRIA
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme, le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,  l'utilisation,  la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant
donn sa spcificit de logiciel libre, qui peut le rendre complexe 
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant des connaissances informatiques approfondies. Les
utilisateurs sont donc invits  charger et tester l'adquation du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement,
 l'utiliser et l'exploiter dans les mmes conditions de scurit.

Le fait que vous puissiez accder  cet en-tte signifie que vous avez
pris connaissance de la licence CeCILL-C, et que vous en avez accept les
termes.

*******************************************************************************}

unit UFormIntro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, UFormRun;//, DiodesPortPar;

type
  TFormIntro = class(TForm)
    lbManips: TListBox;
    lblManips: TLabel;
    btnLancer: TButton;
    btnQuitter: TButton;
    lblSujet: TLabel;
    edtSujet: TEdit;
    lblMarginBottomRight: TLabel;
    lblMarginTopLeft: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnQuitterClick(Sender: TObject);
    procedure btnLancerClick(Sender: TObject);
  public
    procedure Run(manip, subject: String);
  end;

  procedure RecursiveFindIni(relativedir: String; outlist: TStrings);

var
  FormIntro: TFormIntro;

implementation
{$R *.DFM}

procedure TFormIntro.FormCreate(Sender: TObject);
begin

  // dmarre sans bote de dialogue si <manip> et <sujet> passs en paramtres
  if ( ParamCount = 2 ) then
    if ( FileExists(ParamStr(1)) ) then
    begin
      Run(ParamStr(1), ParamStr(2));
      Halt;
    end;

  lbManips.Items.Clear;
  lbManips.Sorted := True;
  ChDir(ExtractFileDir(Application.ExeName));
  RecursiveFindIni('', lbManips.Items);

  // taille dconne sous win XP
  lblMarginTopLeft.Caption := '';
  lblMarginBottomRight.Caption := '';
  Self.AutoSize := True;

end;

procedure RecursiveFindIni(relativedir: String; outlist: TStrings);
var
  F: TSearchRec;
  findresult: Integer;
begin
  findresult := FindFirst(ExtractFilePath(Application.ExeName) + relativedir + '*.ini', faAnyFile, F);
  while ( findresult = 0 ) do
  begin
    outlist.Add(relativedir + F.Name);
    findresult := FindNext(F);
  end;
  FindClose(F);

  findresult := FindFirst(ExtractFilePath(Application.ExeName) + relativedir + '*.*', faDirectory, F);
  while ( findresult = 0 ) do
  begin
    if ( (F.Name <> '.') and (F.Name <> '..') ) then
      RecursiveFindIni(relativedir + F.Name + '\', outlist);
    findresult := FindNext(F);
  end;
  FindClose(F);
end;

procedure TFormIntro.btnLancerClick(Sender: TObject);
begin
  if ( lbManips.ItemIndex = -1 ) then
  begin
    MessageDlg('Vous devez slectionner un fichier de manip.', mtError, [mbOK], 0);
    lbManips.SetFocus;
    Exit;
  end;

  if ( Trim(edtSujet.Text) = '' ) then
  begin
    if ( MessageDlg('Vous n''avez pas saisi le nom du sujet,'#13'voulez-vous continuer quand mme ?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then
    begin
      edtSujet.SetFocus;
      Exit;
    end;
  end;

  Run(ExpandFileName(lbManips.Items[lbManips.ItemIndex]), Trim(edtSujet.Text));
end;

procedure TFormIntro.Run(manip, subject: String);
var
  FormRun: TFormRun;
begin
  FormRun := TFormRun.Create(Self);
  FormRun.LoadFromFile(manip);
  FormRun.SubjectName := subject;
  FormRun.ShowModal;
  FormRun.Free;
end;

procedure TFormIntro.btnQuitterClick(Sender: TObject);
begin
  Close;
end;

end.
