{*******************************************************************************

Unit UTrial.pas

Copyright CNRS (juin 2007)
auteur : Sylvain Mottet
sylvain.mottet @ univ-paris5.fr

Ce logiciel est rgi par la licence CeCILL-C soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL-C telle que diffuse par le CEA, le CNRS et l'INRIA
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme, le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,  l'utilisation,  la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant
donn sa spcificit de logiciel libre, qui peut le rendre complexe 
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant des connaissances informatiques approfondies. Les
utilisateurs sont donc invits  charger et tester l'adquation du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement,
 l'utiliser et l'exploiter dans les mmes conditions de scurit.

Le fait que vous puissiez accder  cet en-tte signifie que vous avez
pris connaissance de la licence CeCILL-C, et que vous en avez accept les
termes.

*******************************************************************************}

unit UTrial;

interface

uses
  UEvent, IniFiles;

type

  TTrial = class
    Name: String;
    Description: String;
    PauseBefore: Boolean;
    Entered: Boolean;
    Events: array of TEvent;

    constructor Create;
    function    AddOptions(options: String): Boolean;
    function    AddEvents(value: String; eventarray: array of TEvent): Boolean;
    procedure   Stop;
  end;

  function FindTrialByName(aotrials: array of TTrial; trname: String): Integer;

implementation

uses
  Dialogs,
  Classes, // TStringList
  Tools;

function FindTrialByName(aotrials: array of TTrial; trname: String): Integer;
var
  i: Integer;
begin
  for i := 0 to High(aotrials) do
    if ( aotrials[i].Name = trname ) then
    begin
      Result := i;
      Exit;
    end;
  Result := -1; // not found
end;

constructor TTrial.Create;
begin
  inherited;
  Self.PauseBefore := False;
  Self.Entered := False;
end;

function TTrial.AddOptions(options: String): Boolean;
var
  i: Integer;
  keylist: TStringList;
begin
  Result := True; // no unknown option
  keylist := TStringList.Create;
  SplitString(options, ',', keylist, fTrim + fLower);
  for i := 0 to keylist.Count - 1 do
  begin
    if ( keylist[i] = 'pause_before' ) then
    begin
      Self.PauseBefore := True;
      continue
    end;
    MessageDlg(PChar('Essai ' + Self.Name + ' : option ' + keylist[i] + ' inconnue.'), mtWarning, [mbOK], 0);
    Result := False;
  end;
end;

function TTrial.AddEvents(value: String; eventarray: array of TEvent): Boolean;
var
  i: Integer;
  eventlist: TStringList;
  eventindex: Integer;
begin
  Result := True;
  eventlist := TStringList.Create;
  SplitString(value, ',', eventlist, fTrim);
  for i := 0 to eventlist.Count - 1 do
  begin
    eventindex := FindEventByName(eventarray, eventlist[i]);
    if ( eventindex = -1 ) then
    begin
      MessageDlg(PChar('Essai ' + Self.Name + ' : stimulus <' + eventlist[i] + '> non trouv.'),
                 mtError, [mbOK], 0);
      Result := False;
    end
    else
    begin
      SetLength(Self.Events, Length(Self.Events) + 1);
      Self.Events[High(Self.Events)] := eventarray[eventindex];
    end;
  end;
end;

procedure TTrial.Stop;
var
  i: Integer;
begin
  for i := 0 to High(Events) do
    Events[i].EndOfTrial;
end;

end.
